package com.microservices.pms.product.service;

import com.microservices.common.core.web.page.GenericsTableDataInfo;
import com.microservices.pms.product.domain.PmsProductPlan;
import com.microservices.pms.product.domain.vo.PmsProductPlanDataVo;

/**
 * 产品计划Service接口
 *
 * @author microservices
 * @date 2023-10-10
 */
public interface IPmsProductPlanService 
{
    /**
     * 查询产品计划
     *
     * @param id        产品计划主键
     * @param checkRole
     * @return 产品计划
     */
    public PmsProductPlan selectPmsProductPlanById(Long id, boolean checkRole);

    /**
     * 查询产品计划列表
     * 
     * @param pmsProductPlan 产品计划
     * @return 产品计划集合
     */
    public GenericsTableDataInfo<PmsProductPlanDataVo> selectPmsProductPlanList(PmsProductPlan pmsProductPlan);

    /**
     * 新增产品计划
     * 
     * @param pmsProductPlan 产品计划
     * @return 结果
     */
    public Long insertPmsProductPlan(PmsProductPlan pmsProductPlan);

    /**
     * 修改产品计划
     * 
     * @param pmsProductPlan 产品计划
     * @return 结果
     */
    public int updatePmsProductPlan(PmsProductPlan pmsProductPlan);

    /**
     * 更新产品计划变更
     *
     * @param id 产品计划Id
     * @return 结果
     */
    public int updatePmsProductPlanChange(Long id);

    /**
     * 批量删除产品计划
     * 
     * @param ids 需要删除的产品计划主键集合
     * @return 结果
     */
    public int deletePmsProductPlanByIds(Long[] ids);

    /**
     * 删除产品计划信息
     * 
     * @param id 产品计划主键
     * @return 结果
     */
    public int deletePmsProductPlanById(Long id);

    /**
     * 查询产品计划详情
     * @param id 产品计划id
     * @return 产品计划详情
     */
    PmsProductPlanDataVo selectPmsProductPlanDataById(Long id);

    /**
     * 查询产品计划数量
     * @param pmsProductPlan 产品计划查询条件
     * @return 产品计划总数
     */
    Integer selectPmsProductPlanCount(PmsProductPlan pmsProductPlan);

    /**
     * 删除产品下所有产品计划
     *
     * @param productIdentifier 产品标识
     */
    void deletePmsProductPlanByProductIdentifier(String productIdentifier);
}
